package edu.mermet.tp8.fenetres;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.DefaultListModel;
import javax.swing.JEditorPane;
import javax.swing.JTextPane;
import javax.swing.JSplitPane;
import javax.swing.SwingConstants;
import java.util.Properties;
import javax.swing.text.PlainDocument;
import java.io.FileReader;
import edu.mermet.tp8.Application;
import java.util.ResourceBundle;
import java.util.Enumeration;

public class JDialogCommentFaire extends JDialog {

	private Application appli;
	
	private DefaultListModel dlm = new DefaultListModel();

	private JList liste = new JList();
	private JEditorPane desc = new JTextPane();

	private ResourceBundle resTitres = ResourceBundle.getBundle("HowTo.titres");
	private ResourceBundle resTextes = ResourceBundle.getBundle("HowTo.textes");


	public JDialogCommentFaire(Application appli){
		super(appli, "Comment Faire ?", false);
		this.appli = appli;
		init();
	}

	private void init(){

		//Initialisation de la liste d'aide
		Enumeration<String> listeTitres = resTitres.getKeys();
		while(listeTitres.hasMoreElements()){
			String titre = resTitres.getString(listeTitres.nextElement());
			dlm.addElement(titre);
		}

		//Génération de la fenêtre
		liste.setModel(dlm);
		liste.addMouseListener(new ActionListe());
		desc.setContentType("text/html");
        desc.setEditable(false);
		JSplitPane pnlPrincipal = new JSplitPane(SwingConstants.VERTICAL, liste, desc);
		add(pnlPrincipal);

		setSize(300,200);
		setLocationRelativeTo(null);
		show();
		addWindowListener(new EcouteurFermeture());
	}

	class EcouteurFermeture extends WindowAdapter{

        public void windowClosing(WindowEvent e){
            appli.enableCommentFaire(true);
        }
    }

    private class ActionListe implements MouseListener {

        @Override
        public void mouseClicked(MouseEvent e) {
            System.out.println(liste.getSelectedValue());
            String val = liste.getSelectedValue().toString();
            Enumeration<String> listeTitres = resTitres.getKeys();
            while(listeTitres.hasMoreElements()){
            	String titre = listeTitres.nextElement();
            	String texte = resTitres.getString(titre);
            	if(val.equals(texte)){
            		desc.setText(resTextes.getString(titre));
            	}
            }
        }
        @Override
        public void mouseExited(MouseEvent e){}
        @Override
        public void mouseEntered(MouseEvent e){}
        @Override
        public void mouseReleased(MouseEvent e){}
        @Override
        public void mousePressed(MouseEvent e){}
    }
}